.Form {
  font-family: sans-serif;
  font-size: 0.8em;
  line-height: $(line_height_compact);
  color: $(color_foreground);
  max-width: 40em;
}

.Form .FieldWrapper-hidden,
.Form .FieldWrapper.hidden,
.Form .Container-hidden,
.Form .Container.hidden,
.Form .hidden {
  display: none !important;
}

.Form .Container {
  padding: 0.5em;
  margin: $(spacing_base) 0;
  position: relative;
  background: $(color_shade);
  border-radius: $(border_radius_accent);

  &:first-child {
    margin-top:0;
  }

  &:last-child {
    margin-bottom:0;
  }

  &.class-DateAndTime {
    background:transparent;
  }

  .Container, .FieldWrapper {
    margin: $(spacing_base) 0;
    &:last-child,
    &.FieldWrapper-class-Submit {
      margin-bottom: 0;
    }

    &:first-child {
      margin-top: 0;
    }
  }
}

.Form .inline-children>.FieldWrapper,
.Form .inline-children>.Container {
  display: inline-block;
  vertical-align: top;
  margin-top: 0;
  margin-bottom: 0;
}

.Form .tips .tip {
  font-size: 0.75em;
  opacity: 0.8;
  line-height: 1.2em;
  margin: 0.5em 0;
}

.Form .tips .tip:first-child {
  margin-top: 0;
}

.Form .tips {
  margin-top: 0.5em;
}

.Form .validation-message {
  background: $(color_error);
  padding: 0.5em;
  margin: 0.5em 0;
  color: #fff;
  border-radius: $(border_radius_accent);
}

.Form .FieldWrapper[data-validation="invalid"],
.Form .Container[data-validation="invalid"] {
  background: $(color_warning);
  color: #fff;
  padding: 0.5em;
  border-radius: $(border_radius_accent);
}

.Form .validation-message:first-child {
  margin-top: 0;
}

.Form .validation-message a {
  text-decoration: none;
  color: #fff !important;
}

.FieldWrapper-Button {
  padding: 0;
  background: transparent;
}

.Form>label {
  font-size: 1.5em !important;
}

.Form label {
  font-weight: bold;
  display: block;
  line-height: 1.2em;
}

.Form .Container>label {
  margin: 0.5em 0;
}

.Form label:first-child {
  font-size: 0.8em;
  margin-top: 0;
}

.FieldWrapper-required label:after,
.Container.required>label:after {
  display: inline;
  content: '\2055';
  color: $(color_accent);
  margin-left: 0.5em;
  font-size: 0.75em;
  vertical-align: middle;
}

.Form input, .Form textarea, .Form select {
  display: block;
  box-sizing: border-box;
  width: 100%;
  border: 1px solid $(color_shade);
  padding: 0.5em;
  font-size: 1.2em;
  border-radius: $(border_radius_accent);
}

.Form textarea {
  box-sizing: border-box;
  display: block;
  width: 100%;
  height: 10em;
}

.Form .Field.class-Checkbox {
  display: none;
}

.Form .Field.class-Checkbox+label {
  display: inline-block;
  vartical-align: middle;
  cursor: pointer;
  font-weight: normal;
  opacity: 0.5;
  font-size: 0.9em;
}

.Form .Field.class-Checkbox+label:hover {
  opacity: 1;
}

.Form .Field.class-Checkbox+label:hover:before {
  color: $(color_notice);
}

.Form .Field.class-Checkbox+label:before {
  font-family: 'Font Awesome 5 Free';
  content: '\f0c8\00A0';
  display: inline-block;
  opacity: 0.25;
}

.Form .Field.class-Checkbox:checked+label {
  opacity: 1;
}

.Form .Field.class-Checkbox:checked+label:before {
  content: '\f14a\00A0';
  color: $(color_confirmation);
  opacity: 1;
}

/*
Slug fields
 */
.Form .Container.class-SlugPattern>label {
  display: none;
}

.Form .Container.class-SlugPattern .FieldWrapper-class-Checkbox {
  display: inline-block;
  vertical-align: middle;
  margin: 0;
}

/*
DateAndTime fields
 */
.Form .Container.class-DateAndTime {
  border: 0;
  padding: 0;
}

.Form .Container.class-DateAndTime>label {
  margin-bottom: 0;
}

.Form .Container.class-DateAndTime input {
  width: auto;
  display: inline-block;
}

/*
progressively-enhanced ordering field
 */
 .FieldWrapper-formward-ordering-field.js-active > textarea {
  display: none;
}

.FieldWrapper-formward-ordering-field {
  ul,.form-ordering-item {
    max-width: none;
    width: 100%:
  }
  .filestore-card {
    background: transparent;
    max-width: 100%;
  }
  .Container {
    margin-bottom:0 !important;
    padding:0;
    background:transparent;
    font-size:0.8em;
  }
}

.FieldWrapper-formward-ordering-field ul {
  margin: 0;
  padding: 0;
  list-style-type: none;
}

.FieldWrapper-formward-ordering-field li {
  margin: 0.25em 0;
  padding: 0.25em;
  background: $(color_shade);
  transition: background-color 0.25s linear;
  cursor: grab;
  position: relative;
  color: $(color_foreground);
  border-radius: $(border_radius_accent);
}

.FieldWrapper-formward-ordering-field li a {
  color: inherit;
  text-decoration: inherit;
}

.FieldWrapper-formward-ordering-field li.deleted {
  background-color: $(color_error);
  color: #fff;
  text-decoration: line-through;
}

.FieldWrapper-formward-ordering-field li.dragging {
  color: #fff;
  background-color: $(color_notice);
  cursor: grabbing;
}

.FieldWrapper-formward-ordering-field .delete-button {
  display: none;
  cursor: pointer;
  position: absolute;
  top: 0.25em;
  right: 0.25em;
  bottom: 0.25em;
  color: $(color_error);
  overflow: hidden;
  text-indent: 100%;
  white-space: nowrap;
  width: 1.5em;
  opacity: 0.5;
  background: #fff;
  border-radius: $(border_radius_accent);
  &:hover {
    background: $(color_error);
    color: #fff;
    opacity: 1;
  }
  &:after {
    font-family: "Font Awesome 5 Free";
    content: "\f2ed";
    text-indent: 0;
    text-align: center;
    display: block;
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    width: 1.5em;
    line-height: 1.5em;
  }
}

.FieldWrapper-formward-ordering-field .deleted .delete-button {
  background: #fff;
  color: $(color_error);
  &:hover {
    background: $(color_confirmation);
    color: #fff;
  }
  &:after {
    content: "\f2ea";
    font-weight: 900;
  }
}

.FieldWrapper-formward-ordering-field.FieldWrapper-deletion-allowed .delete-button {
  display: block;
}

.FieldWrapper-formward-ordering-field.FieldWrapper-deletion-allowed li {
  padding-right: 2em;
}

.FieldWrapper-formward-ordering-field .add-item {
  display: none;
}

.FieldWrapper-formward-ordering-field.FieldWrapper-addition-allowed .add-item {
  display: block;
}

.form-ordering-item .digraph-card {
  margin: 0;
  padding: 0;
}

/* content fields */
.Form .Container.DigraphContent .class-ContentTextarea {
  color: inherit;
  border: 0;
  padding: 0;
  min-height: 300px;
}

.Form .Container.DigraphContent .FieldWrapper-class-ContentTextarea label {
  display: none;
}

.Form .Container.DigraphContent .FieldWrapper-class-ContentFilter label {
  display: none;
}

.Form .Container.class-ContentDefault div.FieldWrapper-class-ContentTextarea
{
  margin-bottom:0 !important;
}

/* buttons */
@fragment button(.Form .Button, $(color_notice));
@fragment button(.Form .Button.Submit, $(color_confirmation));
